/* --------------------------------------------------------------------------
 * BreakOut
 * --------------------------------------------------------------------------
 * prog:  Max Rheiner 
 * date:  26/09/2012 (m/d/y)
 * ----------------------------------------------------------------------------
 */

import ddf.minim.*;

Minim minim;
AudioSample ballHitSnd;
AudioSample ballHitSchlaegerSnd;

BouncingBall ball;
Racket       schlaeger = null;
Brick[]      brickList = null;

Blatt       blaetter = null;

final static int GAME_MODE_MENU      = 0;
final static int GAME_MODE_GAMEOVER  = 2;

final static int GAME_MODE_PLAY_EASY     = 1;
final static int GAME_MODE_PLAY_MEDIUM   = 3;
final static int GAME_MODE_PLAY_HARD     = 4;
boolean newLevel = true;
int          gameMode = GAME_MODE_MENU;
int score = 0; // Punktestand
int level = 1;

int lvlStand = 0;
int brickSize;
int abst;
int Anz;
float valX = 0;
float valY = 0;
boolean einschlag = true;

PImage bad, hoele,gameOver;
void setup()
{
  size(800, 600, P3D); 
  schlaeger = new Racket(0, height - 40, 70, 15);   
  ball = new BouncingBall(width/2, height/2, 7);

  blaetter = new Blatt();
  bad = loadImage("data/badue.png");
  hoele = loadImage("data/hoele.png");
  gameOver = loadImage("data/gameover.png");

  brickSize = 150;
  calcSize(0);
  // sound init
  minim = new Minim(this);
  ballHitSnd = minim.loadSample("hit.mp3");
  ballHitSchlaegerSnd = minim.loadSample("hitSchlaeger.mp3");


  smooth(); 
  noCursor();
}

void calcSize(int red) {
  brickSize -= red;
  int absoAnz = (int)(width/brickSize); // wie viele absolut reinpassen würden
  Anz = absoAnz -2; // für die abstände werden zwei abgezogen
  int absoAbst = (int)(width-(brickSize*Anz)); // absoluter rest gerundet
  abst = (int)(absoAbst/(Anz + 2)); // groesse der abstände einzeln gerundet.
  lvlStand = Anz;
}



void initGameScene()
{
  // setzte die start posititon des balles
  if (level < 2) {
    ball.set(new PVector(width/2, height/2), new PVector(random(-7, 7), -7), 1);
  }
  // erzeuge die ziegel
  //brickList = new Brick[(int)random(3, 12)];
  if (newLevel) {  
    brickList = new Brick[Anz]; 

    int a = 0; // zähler für die Abstände


    for (int i = 0; i < brickList.length;i++) 
    {
      a += abst;
      brickList[i] = new Brick((i * brickSize) + a + (brickSize/2), 100, brickSize, 70);
    }

    newLevel = false;
  }
}

void draw()
{
  // ghosting
  imageMode(CORNER);
  image(hoele, 0, 0);

  //fill(0, 0, 0, 100);
  //rect(0, 0, width, height);
  pushStyle();
  fill(255);
  text("SCORE: " + score, 10, 10, 150, 80); // Score
  text("LEVEL: " + level, 150, 10, 100, 80);
  popStyle();
  drawScene();
  einschlag = blaetter.update(valX, valY, einschlag); // ********* PROBLEM ************
}



void drawScene()
{
  switch(gameMode)
  {
  case GAME_MODE_MENU:
    drawMenu();
    break;
  case GAME_MODE_PLAY_EASY: // standart Paddel von 70
    drawGame();
    schlaeger = new Racket(0, height - 40, 180, 15);   
    break; 
  case GAME_MODE_PLAY_MEDIUM:
    drawGame();
    schlaeger = new Racket(0, height - 40, 80, 15); // Mach das Paddel schmaler
    break; 
  case GAME_MODE_PLAY_HARD:
    drawGame();
    schlaeger = new Racket(0, height - 40, 20, 15);   // Macht das Paddel noch schmaler
    break;  
  case GAME_MODE_GAMEOVER:
    drawGameOver();
    break;
  }
}

void drawMenu()
{
  pushStyle();
  fill(0);
  text("BreakOut", width/2 -100, height/2 - 50);  
  text("1 : Start Game Easy", width/2 - 100, height/2-30); 
  text("2 : Start Game Medium", width/2 - 100, height/2 -10); 
  text("3 : Start Game Hard", width/2 - 100, height/2 +10); 
  text("Space : stop game", width/2 - 100, height/2 + 30);   
  popStyle();
}


void keyPressed()
{
  switch(keyCode) 
  {
  case 49:
    // start game easy
    gameMode = GAME_MODE_PLAY_EASY;
    calcSize(0);
    initGameScene();
    score = 0;
    level = 1;
    newLevel = true;
    lvlStand = Anz;
    break;
  case 50:
    // start game Medium
    gameMode = GAME_MODE_PLAY_MEDIUM;
    calcSize(0);
    initGameScene();
    score = 0;
    level = 1;
    newLevel = true;
    lvlStand = Anz;
    break;
  case 51:
    // start game Hard
    gameMode = GAME_MODE_PLAY_HARD;
    calcSize(0);
    initGameScene();
    score = 0;
    level = 1;
    newLevel = true;
    lvlStand = Anz;
    break;
  case 32: // leertaste
    // end
    gameMode = GAME_MODE_MENU;
    score = 0;
    level = 0;
    break;
  }
}





void drawGame()
{
  // update die daten, berechne kollisionen
  updateScene();

  // zeichne ziegel
  for (int i=0;i < brickList.length;i++)
  {
    if (brickList[i] != null)
      brickList[i].draw();
  }
  // zeichne den ball
  ball.draw();
  // zeichne schlaeger
  schlaeger.draw();
}

void drawGameOver()
{
  pushStyle();
  fill(255);
  imageMode(CORNER);
  image(gameOver,0,0);
  text("Game Over", width/2-200, height/4-50);
  text("Restart mit 1,2 oder 3 !", width/2-200, height/4-251);  
  
  popStyle();
}

void  updateScene()
{
  // test ob ball aus dem spielfeld ist
  if (ball._pos.y > height- ball._r)
  {
    gameMode = GAME_MODE_GAMEOVER;
    return;
  }
  // update schlaeger pos
  schlaeger.move(mouseX, mouseY);

  PVector hitPos = new PVector();
  float  hitV;
  float  speed;

  // teste ob ball den schlaeger trifft
  int retVal = schlaeger.checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir, hitPos);
  /*if (retVal == Brick.HIT_LEFT || retVal == Brick.HIT_RIGTH || retVal == Brick.HIT_TOP || retVal == Brick.HIT_BOTTOM){
   
   }*/


  switch(retVal)
  {
  case Brick.HIT_LEFT:
    // aendere flugrichtung ball
    ball._dir.x *= -1;

    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.x = schlaeger._pos.x - schlaeger._w/2 - ball._r;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break;
  case Brick.HIT_RIGTH:
    // aendere flugrichtung ball
    ball._dir.x *= -1;

    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.x = schlaeger._pos.x + schlaeger._w/2 + ball._r;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break;
  case Brick.HIT_TOP:
    // aendere flugrichtung ball

    // anschnitt berechnen 
    hitV = hitPos.x - (schlaeger._pos.x - schlaeger._w/2);
    hitV = 1.0 / schlaeger._w * hitV - 0.5;

    speed = ball._dir.mag();

    ball._dir.x += hitV * 8; 
    ball._dir.y *= -1;

    // ball soll die gleiche geschwindigkeit haben wie am anfang
    ball._dir.normalize();
    ball._dir.mult(speed);

    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.y = schlaeger._pos.y - schlaeger._h/2 - ball._r ;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break; 
  case Brick.HIT_BOTTOM:
    // aendere flugrichtung ball

    // anschnitt berechnen 
    hitV = hitPos.x - (schlaeger._pos.x - schlaeger._w/2);
    hitV = 1.0 / schlaeger._w * hitV - 0.5;

    speed = ball._dir.mag();

    ball._dir.x += hitV * 8; 
    ball._dir.y *= -1;

    // ball soll die gleiche geschwindigkeit haben wie am anfang
    ball._dir.normalize();
    ball._dir.mult(speed);

    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.y = schlaeger._pos.y + schlaeger._h/2 + ball._r ;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break;
  }

  // test ob ball einen ziegel trifft
  for (int i=0;i < brickList.length;i++)
  {
    if (lvlStand != 0) 
    {
      if (brickList[i] != null)
      {
        retVal = brickList[i].checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir, hitPos); // wenn etwas getroffen wurde zählt es den score hoch

        if (retVal == Brick.HIT_LEFT || retVal == Brick.HIT_RIGTH || retVal == Brick.HIT_TOP ||  retVal == Brick.HIT_BOTTOM) {
          score++;
          lvlStand--;
          einschlag = true;
          valX = hitPos.x;
          valY = hitPos.y;
        }

        if (level*brickList.length == score ) { //**************************************
          newLevel=true;
        }

        switch(retVal)
        {
        case Brick.HIT_LEFT:
        case Brick.HIT_RIGTH:
          // aendere flugrichtung ball
          ball._dir.x *= -1;

          // entferne ziegel aus liste
          brickList[i] = null;


          // spiele sound
          ballHitSnd.trigger();
          break;
        case Brick.HIT_TOP:
        case Brick.HIT_BOTTOM:
          // aendere flugrichtung ball
          ball._dir.y *= -1;

          // entferne ziegel aus liste
          brickList[i] = null;
          // spiele sound
          ballHitSnd.trigger();
          break;
        }
      }
    }
    else { //wenn der Brickszähler (lvlStand) auf null ist wir ein neues level gestartet.
      level++; // level wird hochgesetzt
      calcSize(10); //seiten verhältnisse werden für das Level berechnet 
      lvlStand = Anz; //anzahl der steine wird für das level auf den zähler gelegt
      newLevel = true; // freigabe zum zeichnen wird erteilt      
      initGameScene();
    }
  }
}
